# List Comprehension

L1 = [x*2 for x in range(1, 11)]

L2 = [x*2 for x in range(1, 11) if x*2 >= 12]

# List Comp to find List Length

def length(xs):
   return sum([1 for _ in xs])

# List Comprehension Continued

def rep(x, n):
    return [x for i in range(n)]

def even(x):
    return x%2==0

def odd(x):
    return not(even(x))

def boomBangs(xs):
   return ["BOOM!" if x < 10 else "BANG!" for x in xs if odd(x)]

Lbb = boomBangs(range(1,21))

# List Comprehension With Two Lists
nouns = ["smurf", "frog", "dwarf"]
adjectives = ["lazy", "grouchy", "scheming"]
L3 = [adjective + " " + noun for adjective in adjectives for noun in nouns]

# Remove non UpperCase

def removeNonUpperCase(st):
   upCase = [chr(i) for i in range(ord('A'), ord('Z')+1)]
   return [c for c in st if (c in upCase)]
#  return ''.join([c for c in st if (c in upCase)])

# Nested List Comprehension

xxs = [[1,3,5,2,3,1,2,4,5],[1,2,3,4,5,6,7,8,9],[1,2,4,2,1,6,3,1,3,2,3,6]]

L4 = [[x for x in xs if even(x)] for xs in xxs]

def add3(x):
    return x + 3

L5 = map(add3, [1, 5, 3, 1, 6])
list(L5)

L6 = list(map(lambda x: x+3, [1, 5, 3, 1, 6]))

L7 = list(map(lambda s: s+'!', ["BIFF", "BANG", "POW"]))

